library(Matrix)
library(tseries)
library(kernlab)
source("http://lu-library.googlecode.com/svn/trunk/evaluation.r")


train_batch <- function(splitid, C = 0.1) {
	testidx = which(splits[,splitid]==1)
	trainidx = which(splits[,splitid]==0)
	trmat <- as.kernelMatrix(kernels[trainidx,trainidx])
	tsmat <- as.kernelMatrix(kernels[testidx,trainidx])
	print(splitid)
	
	predictions <-  matrix(0, nrow = length(testidx), ncol = length(event.ids))
	for(eventid in 1:length(event.ids)) {
		trlabels = labels[trainidx, eventid]
		#trlabels[which(trlabels==0)]=-1
		model = ksvm(x=trmat, y=trlabels, type = "C-svc", C = C)
		#trprediction = predict(model, trmat, type = "probabilities")[,which(colnames(trprediction)=="1")]
		thistsmat = as.kernelMatrix(tsmat[,SVindex(model)])
		tsprediction = predict(model, thistsmat, type = "decision")
		#tsprediction = tsprediction[,which(colnames(tsprediction)=="1")]
		predictions[,eventid] = tsprediction
	}
	return(predictions)
}


event.ids <- paste("E",1:16,sep = "")
kernels = read.matrix("data/dev.matrix")
kernels = kernels * 2	#our tool divides pre-calculated kernel by 2 and here we get it back

idlist = as.character(read.table("data/olympic.idlist")[,1])
labels = read.matrix("data/olympic.labels")
splits = as.matrix(read.matrix("data/olympic.splits"))

#batch train
lu = "olympic+batchtrain"
baseline = train_batch(1)
splitid = 1
testidx = which(splits[,splitid]==1)
testlabels = labels[testidx,]
aps = evaluate.map(baseline, testlabels)
print(cbind(event.ids, aps))
print(mean(aps))


